#include "minray_d.h"

/* NOTE This uses "float"
    It does NOT truncate the output file.
    It appends, which is why the T4b2 file was
    twice as big as the T3.6
  
190712 T4b2 and T3.6 used the same uSD card.
On a T4b2 @ 396MHz:
DONE in 211947 ms   3.5 minutes

On a T3.6 @ 180MHz:
DONE in 2555498 ms 42.6 minutes

Previously did one overnight on T3.1
which took 8 hours 53 minutes
*/
// On a Teensy 3.1 @96MHz this took an estimated 8hrs 53mins.
// When PJRC comes out with a Teensy that has floating point
// this will make an interesting benchmark
// 150730 - can't get the SD library to work on T3.1 with 1.6.5/TD
//          and the ST7735 which is probably interfering with CS.
#include <SPI.h>
#include <SD.h>
// On T3.1 with ST7735, CS is pin 4 NOT pin 10

//#define ST7735

#ifdef ST7735
int chip_select = 4;
#else
int chip_select = 10;
#endif
const char *filename = "aek.ppm";
File myFile;

void setup(void)
{
  Serial.begin(9600);
  while(!Serial);
#ifndef ST7735
  SPI.setMOSI(7);
  SPI.setSCK(14);
#endif
  pinMode(chip_select, OUTPUT);

  Serial.printf("Start\n");


  if (SD.begin(chip_select) == false) {
    Serial.println("SD.begin() failed");
    Serial.println("DONE");
    while(1);
  } else {
    Serial.println("SD device opened");
  }  
  myFile = SD.open(filename, FILE_WRITE);
  if(myFile == NULL) {
    // if the file didn't open, print an error:
    Serial.print("error opening ");
    Serial.println(filename);
    while(1);
  }
  Serial.print("Writing to ");
  Serial.println(filename);

uint32_t now = millis();

  build_G("aek");
  char stmp[32];
  // was 512x512
  int width = 512;
  int height = 512;
  sprintf(stmp,"P6 %d %d 255 ",width,height);
  Serial.println(stmp);
  myFile.print(stmp);
  v g=!v(-6,-16,0),a=!(v(0,0,1)^g)*.002,b=!(g^a)*.002,c=(a+b)*-256+g;
  for (int y=height;y--;) {
    for (int x=width;x--;) {
      v p(13,13,13);
      for (int r=64;r--;) {
        v t=a*(R()-.5)*99+b*(R()-.5)*99;
        p=S(v(17,16,8)+t,!(t*-1+(a*(R()+x)+b*(y+R())+c)*16))*3.5+p;
      }
//      Serial.printf("%c%c%c",(int)p.x,(int)p.y,(int)p.z);
      myFile.write((int)p.x);
      myFile.write((int)p.y);
      myFile.write((int)p.z);
    }
    Serial.println(y);
//Serial.printf("\n");
  }
  myFile.close();
  Serial.printf("DONE in %d ms\n",millis()-now);
}

void loop(void)
{
}
