// From: http://scratchapixel.com/lessons/3d-basic-lessons/lesson-1-writing-a-simple-raytracer/source-code/

// PAH - add code to allow the user to specify a string of up to 3 chars
// to use instead of the hard-coded content of the G[] array by using
// the font5x9 array found at:
// http://ftp-archive.freebsd.org/pub/FreeBSD-Archive/old-releases/i386/1.0-RELEASE/ports/xv/bitmaps/font5x9.h

// Usage: minray [name_string] >whatever.ppm
//        imconvert whatever.ppm whatever.gif
// Where:
// name_string is a string of up to 3 ASCII character
// imconvert is the ImageMagick convert program which I use
//		to convert the PPM output to a GIF image
//      imconvert can actually convert to a vast array of other
//		image formats such as JPG, PNG, etc.
//#include "../font5x9.h"
#include <Arduino.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "minray_d.h"


// This codes the letters in a 19 x 9 grid
//i G[]={247570,280596,280600,249748,18578,18577,231184,16,16};
int G[] = {
  0x3c712,
  0x44814,
  0x44818,
  0x3cf94,
  0x04892,
  0x04891,
  0x38710,
  0x00010,
  0x00010
};

void print_G(void)
{
  for(int i = 0x40000;i;i>>=1) {
    for(int j = 8;j >= 0;j--) {
      if(G[8-j] & i)Serial.print("*");
      Serial.print(" ");
    }
    Serial.println();
  }
}
// PAH - create the bitmap in G of the specified letters
void build_G(const char *initials)
{
  // Clear G[]
  for(int i = 0; i < 9;i++) {
    G[i] = 0;
  }
  // The fonts in font5x9 are upside down and left-right mirror images
  // compared to how the original minray program worked so this code
  // performs the reflections needed for each character 
  for(const char *p = initials;*p && (p < initials+3);p++) {
    // [8-i] does the top to bottom reflection
    for(int i = 8;i >= 0;i--) {
      G[8-i] <<= 7;
      int bit = 0x10;
      unsigned char c = font5x9[*p - ' '][i];
      // do the left-right reflection
      for(int j = 0;j < 5;j++) {
        if(c & 1)G[8-i] |=  bit;
        c >>= 1;
        bit >>= 1;
      }
    }
  }
}

float R(void)
{
  return (float)rand()/RAND_MAX;
}

int T(v o,v d,float &t,v &n)
{
  t=1e9;
  int m=0;
  float p=-o.z/d.z;
  if (.01 < p) t=p,n=v(0,0,1),m=1;
  for (int k=19;k--;) {
    for (int j=9;j--;) {
      if (G[j]&1<<k) {
        v p=o+v(-k,0,-j-4);
        float b=p%d,c=p%p-1,q=b*b-c;
        if (q>0) {
          float s=-b-sqrt(q);
          if (s<t&&s>.01)t=s,n=!(p+d*t),m=2;
        }
      }
    }
  }

  return m;
}
v S(v o,v d)
{
  float t;
  v n;
  int m=T(o,d,t,n);
  if (!m)return v(.7,.6,1)*pow(1-d.z,4);
  v h=o+d*t,l=!(v(9+R(),9+R(),16)+h*-1),r=d+n*(n%d*-2);
  float b=l%n;
  if (b<0||T(h,l,t,n))b=0;
  float p=pow(l%r*(b>0),99);
  if (m&1) {
    h=h*.2;
    return((int)(ceil(h.x)+ceil(h.y))&1?v(3,1,1):v(3,3,3))*(b*.2+.1);
  }
  return v(p,p,p)+S(h,r)*.5;
}
